package com.mycompany.getipadd;
import com.huaweicloud.sdk.core.auth.BasicCredentials;
import com.huaweicloud.sdk.core.auth.ICredential;
import com.huaweicloud.sdk.core.exception.ConnectionException;
import com.huaweicloud.sdk.core.exception.RequestTimeoutException;
import com.huaweicloud.sdk.core.exception.ServiceResponseException;
import com.huaweicloud.sdk.dns.v2.DnsClient;
import com.huaweicloud.sdk.dns.v2.model.UpdateRecordSetReq;
import com.huaweicloud.sdk.dns.v2.model.UpdateRecordSetRequest;
import com.huaweicloud.sdk.dns.v2.region.DnsRegion;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Properties;
import java.util.TimeZone;
import java.util.Timer;
import java.util.TimerTask;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;
//<dependency>
//    <groupId>com.huaweicloud.sdk</groupId>
//    <artifactId>huaweicloud-sdk-dns</artifactId>
//    <version>3.0.45</version>
//</dependency>
//引入以上依赖

public class GetIpAdd extends TimerTask 
{
    public static String IPX="";
    public static String IPY="";
    public static final String[] CMDS0={"curl","ifconfig.io"};
    public static final String[] CMDS1={"curl","whatismyip.akamai.com"};
    public static InputStream inputStream;
    public static InputStreamReader inputStreamReader;
    public static BufferedReader bufferedReader;
    public static String str;
    public static StringBuilder stringBuilder;
    public static ProcessBuilder processBuilder; 
    public static Process process;
    
    public static void main(String args[])
    {
        new Timer().scheduleAtFixedRate(new GetIpAdd(), 0, 180000);    
    }
    @Override
    public void run() 
    {       
        IPY = getIp(CMDS0) ;
        if(IPY.replaceAll( "\\d", "").length() != 3)
            IPY = getIp(CMDS1) ;
        if(IPY.replaceAll( "\\d", "").length() == 3&&!IPX.equals(IPY))
        {
            IPX = IPY;
            updateARecord(IPX,"域名id");
            updateARecord(IPX,"域名id");
            //https://apiexplorer.developer.huaweicloud.com/apiexplorer/debug?product=DNS&api=ListRecordSets
            //根据这个地址获取需要修改域名的id和zone_id，这里的id，下面是zone_id
            
        }
    }   
    public static String getIp(String[] CMDS) 
    {
        stringBuilder = new StringBuilder();
        processBuilder = new ProcessBuilder(CMDS);        
        try 
        {  
            process = processBuilder.start();
            inputStream = process.getInputStream();
            inputStreamReader = new InputStreamReader(inputStream);
            bufferedReader = new BufferedReader(inputStreamReader);
            while ((str = bufferedReader.readLine()) != null) 
            {
                stringBuilder.append(str);
                stringBuilder.append(System.getProperty("line.separator"));
            }
        } 
        catch (IOException ex) 
        {
            Logger.getLogger(GetIpAdd.class.getName()).log(Level.SEVERE, null, ex);
        }
        finally
        {
            try 
            {
                inputStream.close();
            } 
            catch (IOException ex) 
            {
                Logger.getLogger(GetIpAdd.class.getName()).log(Level.SEVERE, null, ex);
            }
            try 
            {
                inputStreamReader.close();
            } 
            catch (IOException ex) 
            {
                Logger.getLogger(GetIpAdd.class.getName()).log(Level.SEVERE, null, ex);
            }
            try 
            {
                bufferedReader.close();
            } 
            catch (IOException ex) 
            {
                Logger.getLogger(GetIpAdd.class.getName()).log(Level.SEVERE, null, ex);
            }
        }  
        return stringBuilder.toString().trim();
    }
    public static void updateARecord(String ip,String recordId)
    {
        String ak = "";
        //华为云申请
        String sk = "";
        //华为云申请
        ICredential iCredential = new BasicCredentials().withAk(ak).withSk(sk);
        DnsClient dnsClient = DnsClient.newBuilder().withCredential(iCredential).withRegion(DnsRegion.valueOf("cn-east-3")).build();
        
        UpdateRecordSetRequest updateRecordSetRequest = new UpdateRecordSetRequest();
        updateRecordSetRequest.withZoneId("zoneid");
        //顾名思义
        updateRecordSetRequest.withRecordsetId(recordId);
        UpdateRecordSetReq updateRecordSetReq = new UpdateRecordSetReq();
        List<String> list0 = new ArrayList<>();
        list0.add(ip);
        updateRecordSetReq.withRecords(list0);
        updateRecordSetReq.withType("A");
        updateRecordSetRequest.withBody(updateRecordSetReq);
        try {
            dnsClient.updateRecordSet(updateRecordSetRequest);
        } 
        catch (ConnectionException | RequestTimeoutException e) 
        {
        } 
        catch (ServiceResponseException e) 
        {
            System.out.println(e.getHttpStatusCode());
            System.out.println(e.getErrorCode());
            System.out.println(e.getErrorMsg());
        }
    }
//    public static void setEmail(String str,String str1)
//    {
//        TimeZone.setDefault(TimeZone.getTimeZone("GMT+8"));
//        Calendar calendar = Calendar.getInstance();
//        try {
//            Properties props = new Properties();
//            props.setProperty("mail.smtp.auth", "true");
//            props.setProperty("mail.transport.protocol", "smtp");
//            props.put("mail.smtp.host","smtp.163.com");// smtp服务器地址           
//            Session session = Session.getInstance(props);
//            session.setDebug(true);
//            
//            Message msg = new MimeMessage(session);
//            msg.setSubject(str);
//            msg.setText("IP获取时间为："+new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS").format(calendar.getTime())+",可能的IPV6为："+str1);
//            msg.setFrom(new InternetAddress("a@163.com"));
//            //发件人邮箱
//            msg.setRecipient(Message.RecipientType.TO,new InternetAddress("a@163.com")); 
//            //收件人邮箱
//            msg.saveChanges();
//            Transport transport = session.getTransport();
//            transport.connect("a@163.com","");
//            //发件人邮箱,授权码(可以在邮箱设置中获取到授权码的信息)            
//            transport.sendMessage(msg, msg.getAllRecipients());
//            transport.close();
//        } 
//        catch (MessagingException ex) 
//        {
//            Logger.getLogger(GetIpAdd.class.getName()).log(Level.SEVERE, null, ex);
//        }
//    }
}
